// Generated by CoffeeScript 1.3.1
(function() {

  describe("Item", function() {
    var item;
    item = void 0;
    beforeEach(function() {
      return item = new Item(1, "Mouse", 10);
    });
    describe("Updating an item", function() {
      return it("updates properties passed in", function() {
        item.update({
          title: "Super Mouse",
          price: 15
        });
        expect(item.title).toEqual("Super Mouse");
        expect(item.price).toEqual(15);
        return expect(item.id).toEqual(1);
      });
    });
    describe("protected fields", function() {
      it("should have the ID as a protected field", function() {
        expect(item.protectedFields).toContain("id");
        return expect(item.protectedFields.length).toEqual(1);
      });
      it("should let us add a protected field", function() {
        item.addProtectedField("title");
        return expect(item.protectedFields).toContain("title");
      });
      return it("should not allow protected fields to be updated", function() {
        item.addProtectedField("title");
        item.update({
          id: 2,
          title: "New Title",
          price: 15
        });
        expect(item.id).toEqual(1);
        expect(item.title).toEqual("Mouse");
        return expect(item.price).toEqual(15);
      });
    });
    return describe("fieldIsProtected", function() {
      it("should return true if field is protected", function() {
        return expect(item.fieldIsProtected("id")).toBeTruthy();
      });
      return it("should return false if field is not protected", function() {
        return expect(item.fieldIsProtected("title")).toBeFalsy();
      });
    });
  });

}).call(this);
